import _extends from "@babel/runtime/helpers/esm/extends";
import { generate } from '@ant-design/colors';
import { defaultPresetColors } from '../seed';
import genColorMapToken from '../shared/genColorMapToken';
import genCommonMapToken from '../shared/genCommonMapToken';
import { generateBgPalettes, generateErrorPalettes, generateInfoPalettes, generatePrimaryPalettes, generateSuccessPalettes, generateTextAlphaPalettes, generateWarningPalettes } from './palettes';
export default function derivative(token) {
  var colorPalettes = Object.keys(defaultPresetColors).map(function (colorKey) {
    var colors = generate(token[colorKey]);
    return new Array(10).fill(1).reduce(function (prev, _, i) {
      prev["".concat(colorKey, "-").concat(i + 1)] = colors[i];
      return prev;
    }, {});
  }).reduce(function (prev, cur) {
    prev = _extends(_extends({}, prev), cur);
    return prev;
  }, {});
  var colorBgBase = token.colorBgBase || '#fff';
  var colorTextBase = token.colorTextBase || '#000';
  return _extends(_extends(_extends(_extends({}, token), colorPalettes), genColorMapToken(_extends(_extends({}, token), {
    colorBgBase: colorBgBase,
    colorTextBase: colorTextBase
  }), {
    generatePrimaryPalettes: generatePrimaryPalettes,
    generateErrorPalettes: generateErrorPalettes,
    generateInfoPalettes: generateInfoPalettes,
    generateSuccessPalettes: generateSuccessPalettes,
    generateWarningPalettes: generateWarningPalettes,
    generateBgPalettes: generateBgPalettes,
    generateTextAlphaPalettes: generateTextAlphaPalettes
  })), genCommonMapToken(token));
}